"use strict";
/******************************************************************************
 * This file was generated by langium-cli 0.2.0.
 * DO NOT EDIT MANUALLY!
 ******************************************************************************/
Object.defineProperty(exports, "__esModule", { value: true });
exports.reflection = exports.LangiumNameTestAstReflection = exports.isStepWaitToolForAmountTime = exports.StepWaitToolForAmountTime = exports.isStepSetTemperatureToolToAmountDegree = exports.StepSetTemperatureToolToAmountDegree = exports.isStepMixTool = exports.StepMixTool = exports.isStepAddIngredientAmountToTool = exports.StepAddIngredientAmountToTool = exports.isStepAddIngredientAllToTool = exports.StepAddIngredientAllToTool = exports.isStepAddFromToolAllToTool = exports.StepAddFromToolAllToTool = exports.isUniversalCookingUnit = exports.UniversalCookingUnit = exports.isTool = exports.Tool = exports.isTimeUnit = exports.TimeUnit = exports.isTemperatureSystem = exports.TemperatureSystem = exports.isSteps = exports.Steps = exports.isNewStep = exports.NewStep = exports.isModel = exports.Model = exports.isMetricUnit = exports.MetricUnit = exports.isIngredient = exports.Ingredient = exports.isImperialUnit = exports.ImperialUnit = void 0;
/* eslint-disable @typescript-eslint/array-type */
/* eslint-disable @typescript-eslint/no-empty-interface */
const langium_1 = require("langium");
exports.ImperialUnit = 'ImperialUnit';
function isImperialUnit(item) {
    return exports.reflection.isInstance(item, exports.ImperialUnit);
}
exports.isImperialUnit = isImperialUnit;
exports.Ingredient = 'Ingredient';
function isIngredient(item) {
    return exports.reflection.isInstance(item, exports.Ingredient);
}
exports.isIngredient = isIngredient;
exports.MetricUnit = 'MetricUnit';
function isMetricUnit(item) {
    return exports.reflection.isInstance(item, exports.MetricUnit);
}
exports.isMetricUnit = isMetricUnit;
exports.Model = 'Model';
function isModel(item) {
    return exports.reflection.isInstance(item, exports.Model);
}
exports.isModel = isModel;
exports.NewStep = 'NewStep';
function isNewStep(item) {
    return exports.reflection.isInstance(item, exports.NewStep);
}
exports.isNewStep = isNewStep;
exports.Steps = 'Steps';
function isSteps(item) {
    return exports.reflection.isInstance(item, exports.Steps);
}
exports.isSteps = isSteps;
exports.TemperatureSystem = 'TemperatureSystem';
function isTemperatureSystem(item) {
    return exports.reflection.isInstance(item, exports.TemperatureSystem);
}
exports.isTemperatureSystem = isTemperatureSystem;
exports.TimeUnit = 'TimeUnit';
function isTimeUnit(item) {
    return exports.reflection.isInstance(item, exports.TimeUnit);
}
exports.isTimeUnit = isTimeUnit;
exports.Tool = 'Tool';
function isTool(item) {
    return exports.reflection.isInstance(item, exports.Tool);
}
exports.isTool = isTool;
exports.UniversalCookingUnit = 'UniversalCookingUnit';
function isUniversalCookingUnit(item) {
    return exports.reflection.isInstance(item, exports.UniversalCookingUnit);
}
exports.isUniversalCookingUnit = isUniversalCookingUnit;
exports.StepAddFromToolAllToTool = 'StepAddFromToolAllToTool';
function isStepAddFromToolAllToTool(item) {
    return exports.reflection.isInstance(item, exports.StepAddFromToolAllToTool);
}
exports.isStepAddFromToolAllToTool = isStepAddFromToolAllToTool;
exports.StepAddIngredientAllToTool = 'StepAddIngredientAllToTool';
function isStepAddIngredientAllToTool(item) {
    return exports.reflection.isInstance(item, exports.StepAddIngredientAllToTool);
}
exports.isStepAddIngredientAllToTool = isStepAddIngredientAllToTool;
exports.StepAddIngredientAmountToTool = 'StepAddIngredientAmountToTool';
function isStepAddIngredientAmountToTool(item) {
    return exports.reflection.isInstance(item, exports.StepAddIngredientAmountToTool);
}
exports.isStepAddIngredientAmountToTool = isStepAddIngredientAmountToTool;
exports.StepMixTool = 'StepMixTool';
function isStepMixTool(item) {
    return exports.reflection.isInstance(item, exports.StepMixTool);
}
exports.isStepMixTool = isStepMixTool;
exports.StepSetTemperatureToolToAmountDegree = 'StepSetTemperatureToolToAmountDegree';
function isStepSetTemperatureToolToAmountDegree(item) {
    return exports.reflection.isInstance(item, exports.StepSetTemperatureToolToAmountDegree);
}
exports.isStepSetTemperatureToolToAmountDegree = isStepSetTemperatureToolToAmountDegree;
exports.StepWaitToolForAmountTime = 'StepWaitToolForAmountTime';
function isStepWaitToolForAmountTime(item) {
    return exports.reflection.isInstance(item, exports.StepWaitToolForAmountTime);
}
exports.isStepWaitToolForAmountTime = isStepWaitToolForAmountTime;
class LangiumNameTestAstReflection {
    getAllTypes() {
        return ['ImperialUnit', 'Ingredient', 'MetricUnit', 'Model', 'NewStep', 'Steps', 'TemperatureSystem', 'TimeUnit', 'Tool', 'UniversalCookingUnit', 'StepAddFromToolAllToTool', 'StepAddIngredientAllToTool', 'StepAddIngredientAmountToTool', 'StepMixTool', 'StepSetTemperatureToolToAmountDegree', 'StepWaitToolForAmountTime'];
    }
    isInstance(node, type) {
        return (0, langium_1.isAstNode)(node) && this.isSubtype(node.$type, type);
    }
    isSubtype(subtype, supertype) {
        if (subtype === supertype) {
            return true;
        }
        switch (subtype) {
            case exports.StepAddFromToolAllToTool:
            case exports.StepAddIngredientAllToTool:
            case exports.StepAddIngredientAmountToTool:
            case exports.StepMixTool:
            case exports.StepSetTemperatureToolToAmountDegree:
            case exports.StepWaitToolForAmountTime: {
                return this.isSubtype(exports.NewStep, supertype);
            }
            default: {
                return false;
            }
        }
    }
    getReferenceType(referenceId) {
        switch (referenceId) {
            case 'StepAddFromToolAllToTool:fromTool': {
                return exports.Tool;
            }
            case 'StepAddFromToolAllToTool:toTool': {
                return exports.Tool;
            }
            case 'StepAddIngredientAllToTool:ingredient': {
                return exports.Ingredient;
            }
            case 'StepAddIngredientAllToTool:tool': {
                return exports.Tool;
            }
            case 'StepAddIngredientAmountToTool:ingredient': {
                return exports.Ingredient;
            }
            case 'StepAddIngredientAmountToTool:tool': {
                return exports.Tool;
            }
            case 'StepMixTool:tool': {
                return exports.Tool;
            }
            case 'StepSetTemperatureToolToAmountDegree:tool': {
                return exports.Tool;
            }
            case 'StepWaitToolForAmountTime:tool': {
                return exports.Tool;
            }
            default: {
                throw new Error(`${referenceId} is not a valid reference id.`);
            }
        }
    }
}
exports.LangiumNameTestAstReflection = LangiumNameTestAstReflection;
exports.reflection = new LangiumNameTestAstReflection();
//# sourceMappingURL=ast.js.map